//------------------------------------------------------------

//    Configuration:
//    MCU:             P16F74 ... 16F877A
//    Oscillator:      HS, 08.0000 MHz

//	fcb	%01000000	seg a 	   a
//	fcb	%00100000	seg b 	   --
//	fcb	%00010000	seg c 	f |  | b
//	fcb	%00001000	seg d 	   --   g
//	fcb	%00000100	seg e 	e |  | c
//	fcb	%00000010	seg f 	   --
//	fcb	%00000001	seg g 	    d

//------------------------------------------------------------

void ReadKeys(void);  // return 0=none
void winshow(unsigned char winner);
void delay(void);

// unsigned char GetSeg(unsigned char n);
//------------------------------------------------------------

unsigned char siff[10]={
   0b01111110, //	0
   0b00110000, //	1
	0b01101101, //	2
	0b01111001, //	3
	0b00110011, //	4
	0b01011011, //	5
	0b00011111, //	6
	0b01110000, //	7
	0b01111111, //	8
	0b01110011 //	9
};

unsigned char tdec[8]={	1, 2, 3, 4, 6, 10, 14, 20 };

unsigned char ledspeed;
unsigned char speedcnt;
unsigned char disp1, disp2;
unsigned char inkey;
unsigned char k, nk;
unsigned char game, easy;
unsigned char cnt1, cnt2;
unsigned char maxpoints;

//------------------------------------------------------------
//------------------------------------------------------------

void main() {
   unsigned char i;
   enum st_stat {st_none, st_lose, st_restart} stat;
   unsigned char dir, dirr;
   unsigned char bitma, bitmb;
   unsigned char field;

   TRISA = TRISE = 15;
   TRISB = TRISC = TRISD = 0;
   
   ADCON1 = 7;                     // RA0-RA5, RE0-RE2 =digital io

   disp1=0;
   disp2=0;

   dir=1;
   game=1;
   easy=1;

   while(1) {   // while app
      bitma=255;
      ledspeed=170;
      PORTB = ~siff[disp1];
      PORTC = ~siff[disp2];

      while(1){
         inkey=0;
         delay();
         PORTD=bitma;
         delay();
         if(inkey&4) break;       // start new game
         if(inkey&1) game++;
         if(inkey&2) easy^=1;
         
         if(game==0) {
            bitma=0b10101111;
            bitmb=0b01011111;
            speedcnt=50;
            maxpoints=3;
            if(easy) {
               bitma=0b10111111;
               bitmb=0b01111111;
               speedcnt=170;
            }
         }
         if(game==1){
            bitma=0b10100101;
            bitmb=0b01011010;
            speedcnt=60;
            maxpoints=5;
            if(easy) {
               bitma=0b10111101;
               bitmb=0b01111110;
               speedcnt=140;
            }
         }
         if(game==2){
            bitma=0b11010111;
            bitmb=0b11101011;
            speedcnt=70;
            maxpoints=5;
            if(easy) {
               bitma=0b11101111;
               bitmb=0b11110111;
               speedcnt=140;
            }
         }
         if(game==3){
            bitma=0b11100111;
            bitmb=0b10111101;
            speedcnt=50;
            maxpoints=8;
            if(easy) {
               bitma=0b11111111;
               bitmb=0b10111101;
               speedcnt=85;
            }
         }
         if(game==4) game=0;
         PORTD=bitmb;
      }
      
      disp1=0;
      disp2=0;
      cnt1=0;
      cnt2=0;
      field=0;
      
      PORTB = ~siff[disp1];
      PORTC = ~siff[disp2];

      PORTD =0;
      delay();

      while(1){       // while game
         if(inkey&8) break;   // esc game
         ledspeed=speedcnt;

         if(game==0) dir=2;

         k=0b00000001;
         if(dir==2) k=0b1000000;
         
         // ===============================================
         if(game<2) {     // game =0,1
            while(1){        // while set
               PORTD = ~k;
               stat=st_none;
               inkey=0;

               if(dir==1)  {      // > > > > > >
                  nk=0b1000000;
                  k<<=1;
               }
               else {             // < < < < < <
                  nk=0b00000001;
                  k>>=1;
                  if(game==0) {
                     if(k==2) dir=1;
                  }
               }
               delay();
               if(inkey&8) break;   // esc game

               if(k==0) {
                  if(inkey==0) delay();   // extra
                  if(inkey&8) break;   // esc game
                  if((inkey&dir)==0) {
                     stat=st_lose;
                     break;
                  }
                  dir^=3;
                  k=nk;
                  ledspeed-=tdec[(ledspeed>>5)];

                  if(game==0) {
                     cnt1++;
                     if(cnt1==10){
                        cnt1=0;
                        cnt2++;
                     }
                     if(cnt1==9 && cnt2==9) {
                        break;
                     }
                  }

               }
               else {
                  if(inkey&dir) {
                     if(game==1 || dir==1) {
                        stat=st_lose;
                        break;
                     }
                  }
               }

               if(ledspeed<25) ledspeed=25;
            }   // end while set
         }  // end if(game==0 || game==1)
         
         //---------------------------------------------

         else if(game==2){  // if(game==2)
            k=0b00001000;
            if(dir==2) k=0b00010000;
            dirr=dir;
            while(1){        // while set
               PORTD = ~k;
               stat=st_none;
               inkey=0;

               if(dir==1)  {      // > > > > > >
                  k<<=1;
               }
               else {             // < < < < < <
                  k>>=1;
               }

               if(k==0) {
                  stat=st_lose;
                  break;
               }

               delay();
               if(inkey&8) break;   // esc game
               dir=dirr;
               if(PORTA&1) dir^=3;
               if(PORTA&2) dir^=3;
            }
         }  // end if(game==2)
         
         //---------------------------------------------

         else {  // if(game==3)
            k=0b00000001;
            if(dir==2) k=0b10000000;
            dir^=3;
            inkey=0;
            field&=0b01111110;
            for(i=5; i!=0; i--) {
               PORTD = ~field;
               delay();
               PORTD = ~(k|field);
               delay();
            }
            delay();
            if(inkey&8) break;   // esc game

            while(1){        // while set
               PORTD = ~(k^field);
               stat=st_none;
               inkey=0;

               delay();
               if(inkey&8) break;   // esc game

               if(inkey&dir) {
                  if(k&field){
                     dir^=3;
                     field^=k;
                     stat=st_lose;
                  }
                  else {
                     field|=k;
                     stat=st_restart;
                  }
                  break;
               }

               if(dir==2)  {      // > > > > > >
                  k<<=1;
                  k&=0b01111111;
               }
               else {             // < < < < < <
                  k>>=1;
                  k&=0b11111110;
               }

               if(k==0) {
                  stat=st_lose;
                  break;
               }

            }
         }  // end if(game==3)
         // ===============================================
         
         if(stat==st_lose) {
            if(dir==1)  {
               winshow(1);
               disp2++;
               if( disp2==maxpoints) {
                  break;
               }
            }
            else {
               winshow(2);
               disp1++;
               if( disp1==maxpoints) {
                  break;
               }
            }
         }
         if(stat==st_none) {
            break;
         }

         PORTB = ~siff[disp1];
         PORTC = ~siff[disp2];
      }  // end while game

      delay();
      winshow(3);

      if(game==0) {
         disp1=cnt1;
         disp2=cnt2;
      }

      PORTB = ~siff[disp1];
      PORTC = ~siff[disp2];
      ledspeed=255;
      
      delay();
   }  // end while app
}
//------------------------------------------------------------

void delay(void) {
   unsigned char sb=PORTB;
   unsigned char sc=PORTC;
   unsigned char i;

   for( i=ledspeed; i>0; --i) {
      ReadKeys();
      PORTB=255;
      PORTC=255;
      ReadKeys();
      PORTB=sb;
      PORTC=sc;
   }
}
//------------------------------------------------------------

void winshow(unsigned char winner){
   char i;
   k=2;
   for( i=18; i!=0; --i) {
      Delay_ms(100);
      k<<=1;
      if(k==128) k=2;
      if (winner&1) PORTC=~k;
      if (winner&2) PORTB=~k;
      if ((~PORTA)&8) inkey|=8;
   }
}
//------------------------------------------------------------

void ReadKeys(void) {
   static char a0, a1, a2;

   Delay_ms(1);
   a0=a1;
   a1=a2;
   a2=(~PORTA)&15;
   if(a2==a1 && a2>a0) {
      inkey|=a2;
   }
}
//------------------------------------------------------------


